from calcprint import print_results, write_log
PARAMS = {'precision': None,
        'output_type': None,
        'possible_types': None,
        'dest': None}

def load_params(file="params.ini"):
    global PARAMS
    f = open(file, mode='r', errors='ignore')
    lines = f.readlines()
    for l in lines:
        param = l.split('=')
        param[1] = param[1].strip('\n')

        if param[0] != 'dest':
            param[1] = eval(param[1])
        PARAMS[param[0]] = param[1]

def convert_precision(prec):
    ''''
    Преобразует точность данную в виде числа с плавающей точкой в целое число, возможное для использования с функцией round.
    '''    
    prec=str(prec)
    for i in prec:
        if i=='e':
            x=prec.split('-')
            return int(x[1])
        if i==".":
            x=prec.split('.')
            return int(len(x[1]))

def calculate(*args, action=None, **kwargs):
    load_params()
    global result
    precision = convert_precision(kwargs['precision'])  
    output_type = kwargs['output_type']

    if action == '+':
        result = sum(args)
        if type(result) is not output_type:
            result = output_type(result)

    if action == '-':
        result=0
        for n in args:
            result -= n
        if type(result) is not output_type:
            result = output_type(result)

    if action == '*':
        result = 1
        for n in args:
            result *= n
        if type(result) is not output_type:
            result = output_type(result)
        result = round(result, precision)

    if action == '/':
        result = args[0]
        for n in args:
            result /= n
        if type(result) is not output_type:
            result = output_type(result)
        result = round(result, precision)

    write_log(*args, action=action, result = result)
    return result


if __name__ == "__main__":
    
    load_params()
    print(calculate(*list(range(1, 10)), action = "+", **PARAMS))
    assert PARAMS.get('dest') == 'output.txt', "Имя файла для записи истории вызовов функции calculate должно быть output.txt"
    write_log(*(1.000001, 2.000002, 3.00005), action='+', result='6.000053')
    assert calculate(*list(range(1, 10)), action = "+", **PARAMS) == 45.0 # 1 + 2 + 3 + .. + 9
    assert calculate(*list(range(1, 10)), action = "-", **PARAMS) == -45
    assert calculate(*list(range(1, 5)), action = "/", **PARAMS) == 0.04167 
    assert calculate(*[1.0001, 2.2345], action = "*", **PARAMS)== 2.23472
    print_results(*list(range(1, 10)), action = "+", result=calculate(*list(range(1, 10)), action = "+", **PARAMS))